#ifndef NETWORK_H_
#define NETWORK_H_

#include <boost/asio.hpp>
#include <boost/thread/thread.hpp>

using boost::asio::ip::tcp;
using namespace std;

string GetLocalIPAddress(void);

class Network
{
public:
	Network();
	~Network();

	bool connect( string address, int port);
	void listen(int port, void (*server_connection)(Network&), bool background = true);

	boost::system::error_code send_message(string message);
	string read_message();

	void set_socket(tcp::socket *sock);
	void stop_listen();

	string get_ip_address(void);

//	unsigned char *read_message(size_t n);
//	void send_message(unsigned char *buffer, size_t n);

private:
	void listen_helper(int port, void (*server_connection)(Network&));
	void server_connection_helper(tcp::socket *sock, void (*server_connection)(Network&));

	boost::asio::io_service	m_io_service;
	tcp::socket				*m_socket;
	tcp::acceptor			*m_acceptor;
};

#endif